package Loove 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	
	import net.flashpunk.tweens.misc.NumTween;
	import net.flashpunk.utils.Ease;
	
	import net.flashpunk.FP;
	
	public class HitFlash extends Entity
	{
		[Embed(source = '../../assets/Loove_370x600_Flash_v1.png')] private const FLASH:Class;
		
		private var fader:NumTween = new NumTween(faderEnd);
		public var completed:Boolean = false;
		
		private var mImage:Image = new Image(FLASH);
		
		public function HitFlash() 
		{
			graphic = mImage;
			
			addTween(fader);
			fader.value = 1;
		}
		
		override public function added():void
		{
			fadeIn(0.05);
		}
		
		override public function update():void 
		{
			// Fade in/out alpha control.
			mImage.alpha = fader.value;
			if (fader.value == 1)
			{
				fadeOut(0.5);
			}
			else if (fader.value == 0)
			{
				FP.world.remove(this);
			}
		}
		
		/**
		 * Fades the splash screen in.
		 * @param time	The time the transition will need.
		 */
		private function fadeIn(time:Number=1):void
		{
			fader.tween(0, 1, time, Ease.cubeOut);
			completed = false;
		}
		
		/**
		 * Fades the splash screen out.
		 * @param time	The time the transition will need.
		 */
		private function fadeOut(time:Number=1):void
		{
			fader.tween(1, 0, time, Ease.cubeIn);
			completed = false;
		}
		
		/**
		 * Executes when the fade in/out has finished.
		 */
		private function faderEnd():void 
		{
			completed = true;
		}
	}
}